﻿# You can place the script of your game in this file.

screen battle:
    imagemap:
        ground "Combat.jpg"
        hover "Combat_Hover.jpg"
        
        hotspot(9, 9, 281, 90) action Return("attack")
        hotspot(6, 98, 125, 173) action Return("block")

init:
    python:
        global time_is_up
        import random
        flickrwins = 0
        pages_saved = 0
        time_is_up = False
        
        cats = []
        for i in xrange(10):
            cat = Image("FlickrCats/FlickrCat%02i.jpg" % i, pos=(120,114), anchor=(0, 0))
            catname = "Cat%02i" % i
            renpy.image(catname, cat)
            cats.append(catname)
        
        websites = []
        for i in xrange(36):
            website = Image("Websites/Website%02i.jpg" % i, pos=(120,114), anchor=(0, 0))
            websitename = "Website%02i" % i
            renpy.image(websitename, website)
            websites.append(websitename)
        
        config.layers = [ u'master', u'compy', u'time', u'transient', u'screens', u'overlay' ]
        
        # This function will run a countdown of the given length. It will
        # be white until 5 seconds are left, and then red until 0 seconds are
        # left, and then will blink 0.0 when time is up. 
        def countdown(st, at, length=0.0, func=None):
            global time_is_up
            remaining = length - st

            if remaining > 5.0:
                return Text("%.1f" % remaining, color="#fff", size=72), .1
            elif remaining > 0.0:
                return Text("%.1f" % remaining, color="#f00", size=72), .1
            else:
                time_is_up = True
                return anim.Blink(Text("0.0", color="#f00", size=72)), None        


#Images
image bg adam = "adam.jpg"
image bg zenith = "zenith.jpg"
image fg amber = Image("amber.png", pos=(120,84), anchor=(0, 0))
image fg green = Image("green.png", pos=(120,84), anchor=(0, 0))

image bg basement = "Basement1.jpg"
image bg basement_back = "Basement2.jpg"

image jason steam = "JasonSteam.png"
# image side jason steam = "JasonMug.png"

image paper = "News.jpg"

image monster = "YahooMonster.png"

image socksfeast = "FanciestFeast.jpg"

image discfall = SnowBlossom(Image("disc.png"))

image mu = Null()
image black = "#000000"

# Show a countdown for 30 seconds.
image countdown = DynamicDisplayable(countdown, length=30.0)


# Characters
define jason = Character('Jason Scott', image="jason")
define socks = Character('Sockington')
define yahoo = Character('The Yahoo Monster')
define news = Character('The News')

# Transitions
define slidebothleft = ComposeTransition(CropMove(0.2, mode="slideleft"), before=CropMove(0.2, mode="slideawayleft"))

# The game starts here.
label start:
    scene bg basement
    show jason steam
    
    jason "Hi!"
    jason "I'm Jason Scott, computer historian extraordinaire!"
    jason "Right now I'm trying to archive Flickr, won't you help me?"
    
    jump flickr_howto

    return

label flickr_howto:
    jason "I'll give you a computer terminal."
    jason "If the screen is green, type WGET"
    jason "But if the screen is amber, type CURL"
    menu:
        jason "Are you ready?"
        "Yes!":
            jason "Okay, let's go!"
            jump flickr_game
        "No.":
            jason "Well, I'll explain again."
            jump flickr_howto
    return

label flickr_game:
    jump cat

label cat:
    $ ok = False;
    $ cat = random.choice(cats)
    if random.randint(0,1) == 1:
        scene bg zenith onlayer compy
        $renpy.show(cat, layer=u'compy')
        show fg green onlayer compy
        with slidebothleft
        $ ok = renpy.input("> ").lower() == "wget"
    else:
        scene bg adam onlayer compy
        $renpy.show(cat, layer=u'compy')
        show fg amber onlayer compy
        with slidebothleft
        $ ok = renpy.input("> ").lower() == "curl"
    if ok:
        play sound "clang.wav"
        $ flickrwins += 1
    else:
        play sound "beepno.wav"
    
    if flickrwins > 5:
        jump ohno
    else:
        jump cat
    return

label ohno:
    scene mu onlayer compy
    scene mu onlayer time
    with slidebothleft
    
    jason "Okay, next is..."
    jason "Wait a moment, what's this?"
    
    show jason steam at left
    show paper at right behind jason
    with moveinright
    
    news "THIS JUST IN: YAHOO HAS PURCHASED EVERY WEB PAGE ON THE INTERNET!"
    jason "Oh no! I bet they'll start deleting things any moment now!"
    news "THIS JUST IN: YAHOO HAS ANNOUNCED THAT, TO CUT COSTS, THEY ARE DELETING EVERY WEB PAGE ON THE INTERNET!"
    jason "Quick! Start saving pages!"
    jump save_the_internet

label save_the_internet:
    show countdown onlayer time
    jump web

label web:
    $ ok = False;
    $ website = random.choice(websites)
    if random.randint(0,1) == 1:
        scene bg zenith onlayer compy
        $renpy.show(website, layer=u'compy')
        show fg green onlayer compy
        with slidebothleft
        $ ok = renpy.input("> ").lower() == "wget"
    else:
        scene bg adam onlayer compy
        $renpy.show(website, layer=u'compy')
        show fg amber onlayer compy
        with slidebothleft
        $ ok = renpy.input("> ").lower() == "curl"
    if ok:
        play sound "clang.wav"
        $ pages_saved += 1
    else:
        play sound "beepno.wav"
    
    if time_is_up:
        jump yahoo_visit
    
    jump web

label yahoo_visit:
    scene mu onlayer compy
    scene mu onlayer time
    scene bg basement_back
    show jason steam at center
    with slidebothleft
    
    show jason steam at left
    show monster at right behind jason
    with moveinright
    
    yahoo "OH HELLO"
    jason "Wh... what? How did you get past the guard?"
    yahoo "YAHOO HAS ITS WAYS"
    
    scene socksfeast
    socks "THIS IS THE FANCIEST OF ALL POSSIBLE FEASTS"
    
    scene bg basement_back
    show jason steam at left
    show monster at right behind jason
    
    jason "What do you want, monster?"
    yahoo "I WANT TO BUY YOU AND ALL THE PAGES YOU SAVED, HERE IS MILLIONS OF DOLLARS"
    jason "Never! You'll just delete all that history!"
    yahoo "SO BE IT. I WILL JUST TAKE IT BY FORCE!"
    yahoo "I CANNOT BE STOPPED FROM DEVOURING ALL!"
    
    "FIGHT START!"
    
    jump yahoo_fight_start

label yahoo_fight_start:
    $ yahoo_hp = 300
    $ yahoo_is_charging = False
    $ jason_hp = pages_saved

label yahoo_fight:
    $ narrator("Yahoo HP: %i\nJason's HP:%i" % (yahoo_hp, jason_hp))
    window hide None
    call screen battle
    window show None
    
    if _return == "attack":
        "Jason slices with a Novation Apple-Cat Modem!"
        play sound "punch.wav"
        "He deals 50 damage!"
        $ yahoo_hp -= 50
        $ blocking = False
    elif _return == "block":
        show discfall
        "Jason throws a stack of documentaries into the air!"
        $ blocking = True
    
    if yahoo_hp < 1:
        jump jason_wins
    
    if yahoo_is_charging:
        "The Yahoo Monster fires lasers from its many mouths!"
        play sound "lasergun.wav"
        if blocking:
            "But Jason deflects them with his one thousand disc film!"
        else:
            "Jason takes 10 damage!"
            $ jason_hp -= 10
        $ yahoo_is_charging = False
    else:
        if random.randint(0, 5) == 0:
            "The Yahoo Monster begins humming to itself..."
            $ yahoo_is_charging = True
        else:
            "The Yahoo Monster gives Jason a lot of money!"
            play sound "punch.wav"
            if blocking:
                $ damage = random.randint(0, 3)
                $ narrator("Jason resists by selling DVDs, and takes only %i damage." % damage)
            else:
                $ damage = random.randint(1, 6)
                $ narrator("Jason takes %i damage" % damage)
            $ jason_hp -= damage
            
    if jason_hp < 1:
        jump yahoo_wins
    
    jump yahoo_fight

label jason_wins:
    scene black
    with dissolve
    
    "Jason has defeated the monster! The history and the majesty of the internet is preserved!"
    "But... For how long?"
    
    "GOOD END"
    
    $ renpy.quit()
    return
    
label yahoo_wins:
    "Jason is out of HP..."
    jason "Fine! I'll sell!"
    hide jason
    with moveoutleft
    
    show monster at center
    with move
    
    yahoo "HAHAHA! AND I WILL JUST DEVOUR ALL THE WEBSITES YOU HAVE TRIED SO HARD TO SAVE!"
    yahoo "YUM!"
    
    scene black
    with dissolve
    
    "And so, the internet was destroyed forever."
    "And it's all your fault."
    "Asshole."
    
    "BAD END"
    
    $ renpy.quit()
    return
